c<template>
  <div>
    <modal name="docs-list"
           class="arcticmodal-container full-viewport"
           width="600"
           height="auto"
           :adaptive=true
           @before-open="beforeOpen"
           @before-close="beforeClose">
      <div class="container m-header">
        <div
                @click="close()"
                class="box-modal_close arcticmodal-close"></div>
        <div class="row">
          <div class="column">
            <h3>Список документов по займу</h3>
          </div>
        </div>
      </div>
      <div class="container content feedback-block">
        <ajax-loader v-if="loading"></ajax-loader>
        <div v-else v-for="doc in docs" class="row details">
          <a @click.prevent="openDocument(doc)" href="#">
            <div class="picto"><img src="/lk/static/img/notification/docs.png" alt="">
            </div>
            {{ doc.document_name }}
          </a>
        </div>
      </div>
    </modal>

    <modal name="statement"
           class="arcticmodal-container full-viewport"
           width="600"
           height="auto"
           :adaptive=true>
      <div class="container m-header">
        <div
                @click="$modal.hide('statement');"
                class="box-modal_close arcticmodal-close"></div>
        <div class="row">
          <div class="column">
            <h3>{{statement_title}}</h3>
          </div>
        </div>
      </div>
      <div class="container content feedback-block" v-html="statement_content"></div>
    </modal>
  </div>
</template>
<script>
  import {getLoanById} from '@/utils/api'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import {UNSET_ERRORS} from '@/store/mutation-types'
  import backendApi from '@/utils/backend-api'
  import loader from '@/base/Loader/'
  import Vue from 'vue'
  export default {
    name: 'docs-list',
    data () {
      return {
        loading: true,
        params: {},
        docs: [],
        bodyFix: false,
        bodyPrevStyles: '',
        statement_content: '',
        statement_title: '',
      }
    },
    mixins: [
      ErrorHandleMixin
    ],
    components: {
    },
    methods: {
      async beforeOpen (event) {
        this.$helpers.noscroll(true);
        this.docs = []
        this.loading = true
        this.params = event.params
        try {
          this.docs = await getLoanById(this.params.creditId) // Загрузка займов
        } catch (e) {}
        this.loading = false

      },
      async openDocument (doc) {
        const documentUrl = doc.document_url;

        const isPdf = (url) => {
          const regex = [/pdf\/\d+/, /_pdf\//];

          return regex.find((r) => {
            return r.test(url);
          })
        }

        if(isPdf(documentUrl)) {
          const win = window.open('about:blank', 'Doc', 'status=0,title=0,height=600,width=1000,scrollbars=1')
          this.createLoader(win)
          this.$backend.getPDF(`documents/${documentUrl}`).then(({data}) => {
            const newBlob = new Blob([data], {type: 'application/pdf'})
            if (window.navigator && window.navigator.msSaveOrOpenBlob) {
              window.navigator.msSaveOrOpenBlob(newBlob)
              return
            }
            const url = window.URL.createObjectURL(newBlob);
            const time = new Date();
            win.addEventListener('close', () => {
              const timer = time - new Date();
              if (timer < 3000) {
                this.$toastr.error('Кажется у вас установлен Adblock, который блокирует показ документа.', 'Отключите блокировщик рекламы');
                this.$backend.log({
                  adblock: 1,
                  document: doc,
                  user_id: this.$user.id,
                  user_login: this.$user.login
                })
              }
            });
            win.document.location.href = url;

          }).catch((e) => {
            this.$toastr.error('Не удалось загрузить документ. Попробуйте снова или обратитесь в службу поддержки.', 'Ошибка');
            win.close();
          })
        } else {
          this.AJAX_LOADING(true);
          if(documentUrl.startsWith('statement')) {
            try {
              const {data} = await this.$backend.api.documents.byUrl(`${documentUrl}`);
              const content = data.content || data // По statements отдается объект а по остальным сырой html
              this.openModal(content, doc);
            } catch (e) {
              this.$toastr.error('Не удалось загрузить документ. Обратитесь в службу поддержки', 'Ошибка');
            }
          } else {
            const win = window.open('about:blank', 'Document', 'status=0,title=0,height=600,width=1200,scrollbars=1');
            if (!win) {
              this.$toastr.warning('Кажется, у вас заблокированы всплывающие окна. Добавьте сайт webbankir.com в исключения вашего браузера', 'Предупреждение');
              return;
            }
            this.createLoader(win);
            const {data} = await this.$backend.api.documents.byUrl(`${documentUrl}`);
            const content = data.content || data // По statements отдается объект а по остальным сырой html
            win.document.write(content);
            win.focus();

          }
          this.AJAX_LOADING(false);
        }
      },

      openModal(content, doc) {
        this.statement_content = content;
        this.statement_title = doc.document_name;
        this.$modal.show('statement');
      },

      createLoader (win) {
        const body = win.document.body
        const Component = Vue.extend(loader)
        const element = new Component().$mount().$el
        body.appendChild(element)
        const style = document.createElement('style')
        style.setAttribute('type', 'text/css')
        // не нужно пугаться этого ужаса
        style.innerText = `#floatingCirclesG{
    position:relative;
    width:125px;
    height:125px;
    margin:auto;
    transform:scale(0.6);
    -o-transform:scale(0.6);
    -ms-transform:scale(0.6);
    -webkit-transform:scale(0.6);
    -moz-transform:scale(0.6);
  }

  .f_circleG{
    position:absolute;
    background-color:rgb(255,255,255);
    height:22px;
    width:22px;
    border-radius:12px;
    -o-border-radius:12px;
    -ms-border-radius:12px;
    -webkit-border-radius:12px;
    -moz-border-radius:12px;
    animation-name:f_fadeG;
    -o-animation-name:f_fadeG;
    -ms-animation-name:f_fadeG;
    -webkit-animation-name:f_fadeG;
    -moz-animation-name:f_fadeG;
    animation-duration:1.2s;
    -o-animation-duration:1.2s;
    -ms-animation-duration:1.2s;
    -webkit-animation-duration:1.2s;
    -moz-animation-duration:1.2s;
    animation-iteration-count:infinite;
    -o-animation-iteration-count:infinite;
    -ms-animation-iteration-count:infinite;
    -webkit-animation-iteration-count:infinite;
    -moz-animation-iteration-count:infinite;
    animation-direction:normal;
    -o-animation-direction:normal;
    -ms-animation-direction:normal;
    -webkit-animation-direction:normal;
    -moz-animation-direction:normal;
  }

  #frotateG_01{
    left:0;
    top:51px;
    animation-delay:0.45s;
    -o-animation-delay:0.45s;
    -ms-animation-delay:0.45s;
    -webkit-animation-delay:0.45s;
    -moz-animation-delay:0.45s;
  }

  #frotateG_02{
    left:15px;
    top:15px;
    animation-delay:0.6s;
    -o-animation-delay:0.6s;
    -ms-animation-delay:0.6s;
    -webkit-animation-delay:0.6s;
    -moz-animation-delay:0.6s;
  }

  #frotateG_03{
    left:51px;
    top:0;
    animation-delay:0.75s;
    -o-animation-delay:0.75s;
    -ms-animation-delay:0.75s;
    -webkit-animation-delay:0.75s;
    -moz-animation-delay:0.75s;
  }

  #frotateG_04{
    right:15px;
    top:15px;
    animation-delay:0.9s;
    -o-animation-delay:0.9s;
    -ms-animation-delay:0.9s;
    -webkit-animation-delay:0.9s;
    -moz-animation-delay:0.9s;
  }

  #frotateG_05{
    right:0;
    top:51px;
    animation-delay:1.05s;
    -o-animation-delay:1.05s;
    -ms-animation-delay:1.05s;
    -webkit-animation-delay:1.05s;
    -moz-animation-delay:1.05s;
  }

  #frotateG_06{
    right:15px;
    bottom:15px;
    animation-delay:1.2s;
    -o-animation-delay:1.2s;
    -ms-animation-delay:1.2s;
    -webkit-animation-delay:1.2s;
    -moz-animation-delay:1.2s;
  }

  #frotateG_07{
    left:51px;
    bottom:0;
    animation-delay:1.35s;
    -o-animation-delay:1.35s;
    -ms-animation-delay:1.35s;
    -webkit-animation-delay:1.35s;
    -moz-animation-delay:1.35s;
  }

  #frotateG_08{
    left:15px;
    bottom:15px;
    animation-delay:1.5s;
    -o-animation-delay:1.5s;
    -ms-animation-delay:1.5s;
    -webkit-animation-delay:1.5s;
    -moz-animation-delay:1.5s;
  }



  @keyframes f_fadeG{
    0%{
      background-color:rgb(0,0,0);
    }

    100%{
      background-color:rgb(255,255,255);
    }
  }

  @-o-keyframes f_fadeG{
    0%{
      background-color:rgb(0,0,0);
    }

    100%{
      background-color:rgb(255,255,255);
    }
  }

  @-ms-keyframes f_fadeG{
    0%{
      background-color:rgb(0,0,0);
    }

    100%{
      background-color:rgb(255,255,255);
    }
  }

  @-webkit-keyframes f_fadeG{
    0%{
      background-color:rgb(0,0,0);
    }

    100%{
      background-color:rgb(255,255,255);
    }
  }

  @-moz-keyframes f_fadeG{
    0%{
      background-color:rgb(0,0,0);
    }

    100%{
      background-color:rgb(255,255,255);
    }
  }`
        win.document.querySelector('head').appendChild(style)
      },
      beforeClose () {
        this.$helpers.noscroll(false);
        this.$store.commit(UNSET_ERRORS)
      },
      close () {
        this.$modal.hide('docs-list');
      }
    }
  }
</script>
<style scoped>
  h3 {
    margin-bottom: 0px !important;
  }
  .buttons {
    text-align: center
  }
</style>
